"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HtmlEditor = void 0;
var react_1 = __importStar(require("react"));
var lodash_1 = require("lodash");
var css_1 = __importDefault(require("primeobjects-ui-web-store/build/cjs/css"));
var core_1 = require("primeobjects-helper-util/build/cjs/core");
var uuid_1 = require("primeobjects-helper-util/build/cjs/uuid");
var react_2 = require("@tiptap/react");
var extension_typography_1 = __importDefault(require("@tiptap/extension-typography"));
var extension_link_1 = __importDefault(require("@tiptap/extension-link"));
var extension_image_1 = __importDefault(require("@tiptap/extension-image"));
var extension_dropcursor_1 = __importDefault(require("@tiptap/extension-dropcursor"));
var starter_kit_1 = __importDefault(require("@tiptap/starter-kit"));
var extension_code_block_lowlight_1 = __importDefault(require("@tiptap/extension-code-block-lowlight"));
var html_code_1 = __importDefault(require("./html-code"));
var extension_highlight_1 = __importDefault(require("@tiptap/extension-highlight"));
var extension_color_1 = __importDefault(require("@tiptap/extension-color"));
var html_css_1 = require("./html-css");
var html_code_css_1 = require("./html-code-css");
var lowlight_1 = __importDefault(require("lowlight"));
var html_float_edit_toolbar_1 = __importDefault(require("./html-float-edit-toolbar"));
var html_float_insert_toolbar_1 = __importDefault(require("./html-float-insert-toolbar"));
var html_float_highlight_toolbar_1 = __importDefault(require("./html-float-highlight-toolbar"));
// load specific languages only
// import lowlight from 'lowlight/lib/core'
// import javascript from 'highlight.js/lib/languages/javascript'
// lowlight.registerLanguage('javascript', javascript)
var HtmlEditor = function (props) {
    var highlightCustomButtons = props.highlightCustomButtons, onHighlight = props.onHighlight;
    var placeholder = (0, core_1.isNonEmptyString)(props.placeholder) ? props.placeholder : "";
    var _a = (0, react_1.useState)((0, core_1.isNonEmptyString)(props.content) ? props.content : ""), content = _a[0], setContent = _a[1];
    var id = (0, react_1.useState)((0, core_1.isNonEmptyString)(props.id) ? props.id : (0, uuid_1.newGuid)())[0];
    var _b = (0, react_1.useState)(!(0, lodash_1.isNil)(props.recordId) && (0, core_1.isNonEmptyString)(props.recordId) ? props.recordId : (0, uuid_1.newGuid)()), recordId = _b[0], setRecordId = _b[1];
    var className = props.className ? props.className : "";
    var style = props.style ? props.style : {};
    var inputClassName = props.inputClassName ? props.inputClassName : "";
    var inputStyle = props.inputStyle ? props.inputStyle : {};
    var readonly = (0, react_1.useRef)(props.readonly == true);
    var hideH1 = props.hideH1 == true;
    var hideH2 = props.hideH2 == true;
    var hideH3 = props.hideH3 == true;
    var hideH4 = props.hideH4 == true;
    var supportSourceCode = props.supportSourceCode == true;
    var supportHighlight = props.supportHighlight == true;
    var entityName = !(0, lodash_1.isNil)(props.entityName) && (0, core_1.isNonEmptyString)(props.entityName) ? props.entityName : "HTMLEditor";
    var attributeName = !(0, lodash_1.isNil)(props.attributeName) && (0, core_1.isNonEmptyString)(props.attributeName) ? props.attributeName : "content";
    var highlightColors = !(0, lodash_1.isNil)(props.highlightColors) && (0, lodash_1.isArray)(props.highlightColors) ? props.highlightColors : [];
    (0, react_1.useEffect)(function () {
        if (!(0, lodash_1.isNil)(props.recordId) && (0, core_1.isNonEmptyString)(props.recordId)) {
            setRecordId(props.recordId);
        }
    }, [props.recordId]);
    (0, react_1.useEffect)(function () {
        readonly.current = props.readonly == true;
        onInit();
    }, [props.readonly]);
    (0, react_1.useEffect)(function () {
        var newContent = (0, core_1.isNonEmptyString)(props.content) ? props.content : "";
        setContent(newContent);
    }, [props.content]);
    var setPrevContent = function (content) {
        var o = document.getElementById("html-for-prev-".concat(id));
        if (o)
            o.innerHTML = content;
    };
    var getPrevContent = function () {
        var o = document.getElementById("html-for-prev-".concat(id));
        return o ? o.innerHTML : "";
    };
    var onInit = function () {
        var htmlEditor = document.getElementsByClassName("html-editor-".concat(id));
        htmlEditor = htmlEditor.length > 0 && htmlEditor[0];
        var editorDivs = htmlEditor === null || htmlEditor === void 0 ? void 0 : htmlEditor.getElementsByClassName("ProseMirror");
        if (editorDivs && editorDivs.length > 0) {
            if (readonly.current) {
                editorDivs[0].setAttribute("contenteditable", "false");
            }
            else {
                editorDivs[0].setAttribute("contenteditable", "true");
            }
            //remove empty br
            var fieldEmptyBr = htmlEditor === null || htmlEditor === void 0 ? void 0 : htmlEditor.getElementsByClassName("ProseMirror-trailingBreak");
            for (var i = 0; i < fieldEmptyBr.length; i++) {
                if (fieldEmptyBr[i].tagName == "BR" && fieldEmptyBr[i].parentElement.children.length == 1) {
                    fieldEmptyBr[i].parentElement.remove();
                }
            }
        }
    };
    var onEvent = function (editor, action, info) {
        var _a, _b, _c, _d;
        var html = editor.getHTML();
        var htmlEditor = document.getElementsByClassName("html-editor-".concat(id));
        htmlEditor = htmlEditor.length > 0 && htmlEditor[0];
        if (action == "init") {
            setTimeout(function () {
                setPrevContent(html);
                onInit();
                if ((0, lodash_1.isFunction)(props.onReady))
                    props.onReady();
            }, 200);
        }
        if ((action == "init" || action == "blur") && (html == "<p></p>" || html == "<p></p><p></p>")) {
            if (htmlEditor)
                htmlEditor.className = "".concat(htmlEditor.className, " is-placeholder html-editor-").concat(id, "-is-placeholder");
            (_a = editor === null || editor === void 0 ? void 0 : editor.commands) === null || _a === void 0 ? void 0 : _a.setContent("<p>".concat(placeholder, "</p>"));
        }
        if (action == "focus" && html == "<p>".concat(placeholder, "</p>")) {
            if (htmlEditor)
                htmlEditor.className = htmlEditor.className.replace("html-editor-".concat(id, "-is-placeholder"), "").replace("is-placeholder", "").trim();
            (_b = editor === null || editor === void 0 ? void 0 : editor.commands) === null || _b === void 0 ? void 0 : _b.setContent("<p></p><p></p>");
        }
        if ((action == "selection" || action == "focus") && htmlEditor) {
            if (html == "<p></p>") {
                if (htmlEditor.className.indexOf("is-empty") < 0)
                    htmlEditor.className = "".concat(htmlEditor.className, " is-empty");
            }
            else {
                if (htmlEditor.className.indexOf("is-empty") > 0)
                    htmlEditor.className = htmlEditor.className.replace("is-empty", "");
            }
        }
        if (action == "update") {
            if (htmlEditor)
                htmlEditor.className = htmlEditor.className.replace("html-editor-".concat(id, "-is-placeholder"), "").replace("is-placeholder", "").trim();
            if (readonly.current && (info === null || info === void 0 ? void 0 : info.type) == "paste") {
                //rollback
                (_c = editor === null || editor === void 0 ? void 0 : editor.commands) === null || _c === void 0 ? void 0 : _c.setContent(getPrevContent());
            }
            (_d = document.getElementById("html-for-sync-".concat(id))) === null || _d === void 0 ? void 0 : _d.click();
        }
    };
    var editor = (0, react_2.useEditor)({
        content: content,
        extensions: [
            starter_kit_1.default,
            extension_highlight_1.default.configure({ multicolor: true }),
            extension_color_1.default,
            extension_link_1.default.configure({
                openOnClick: false
            }),
            extension_image_1.default,
            extension_dropcursor_1.default,
            extension_typography_1.default,
            extension_code_block_lowlight_1.default.extend({
                addNodeView: function () {
                    return (0, react_2.ReactNodeViewRenderer)(function (props) {
                        return react_1.default.createElement(html_code_1.default, __assign({}, props, { readonly: readonly.current }));
                    });
                }
            }).configure({ lowlight: lowlight_1.default })
        ],
        onBeforeCreate: function () {
            //const { editor } = createParams;
        },
        onCreate: function (_a) {
            var _b;
            var editor = _a.editor;
            //the line below has to be done here, do not move inside onEvent
            (_b = document.getElementById("html-for-init-".concat(id))) === null || _b === void 0 ? void 0 : _b.click();
            onEvent(editor, "init");
        },
        onUpdate: function (updateParams) {
            var _a;
            var editor = updateParams.editor;
            var transaction = updateParams.transaction;
            //const transaction: Record<string, any> = updateParams?.transaction;
            onEvent(editor, "update", { type: ((_a = transaction === null || transaction === void 0 ? void 0 : transaction.meta) === null || _a === void 0 ? void 0 : _a.paste) == true ? "paste" : "default" });
        },
        onSelectionUpdate: function (_a) {
            var editor = _a.editor;
            onEvent(editor, "selection");
            // editor.chain().focus().setImage({ src: url }).run()
            // The selection has changed.
        },
        onTransaction: function (_a) {
            var editor = _a.editor;
            onEvent(editor, "transaction");
            // The editor state has changed.
        },
        onFocus: function (_a) {
            var editor = _a.editor;
            onEvent(editor, "focus");
        },
        onBlur: function (_a) {
            var editor = _a.editor;
            onEvent(editor, "blur");
        },
        onDestroy: function () {
            // The editor is being destroyed.
        }
    }, [recordId]);
    var onInitContent = function () {
        var _a;
        var curValue = editor === null || editor === void 0 ? void 0 : editor.getHTML();
        if (curValue != content) {
            (_a = editor === null || editor === void 0 ? void 0 : editor.commands) === null || _a === void 0 ? void 0 : _a.setContent(content);
        }
    };
    var onSyncContent = function () {
        var newContent = editor === null || editor === void 0 ? void 0 : editor.getHTML();
        if (newContent == "" || newContent == "<p></p>")
            newContent = "<p></p><p></p>";
        setPrevContent(newContent);
        setContent(newContent);
        if ((0, lodash_1.isFunction)(props.onChange))
            props.onChange((0, core_1.isNonEmptyString)(newContent) ? newContent : "");
    };
    return (0, core_1.isSSR)() ? (react_1.default.createElement(react_1.default.Fragment, null)) : (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(css_1.default, { id: "html-editor-css", content: html_css_1.HTML_EDITOR_CSS }),
        react_1.default.createElement(css_1.default, { id: "html-editor-code-css", content: html_code_css_1.HTML_EDITOR_CODE_CSS }),
        react_1.default.createElement("div", { className: "w-full html-editor html-editor-".concat(id, " ").concat(readonly.current == true ? "readonly-true" : "readonly-false", " ").concat(className), style: style },
            editor && react_1.default.createElement(html_float_insert_toolbar_1.default, { recordId: recordId, entityName: entityName, attributeName: attributeName, editor: editor }),
            editor && (react_1.default.createElement(html_float_edit_toolbar_1.default, { editor: editor, hideH1: hideH1, hideH2: hideH2, hideH3: hideH3, hideH4: hideH4, supportHighlight: supportHighlight, supportSourceCode: supportSourceCode })),
            editor && supportHighlight && react_1.default.createElement(html_float_highlight_toolbar_1.default, { editor: editor, colors: highlightColors, customButtons: highlightCustomButtons, onHighlight: onHighlight }),
            react_1.default.createElement(react_2.EditorContent, { editor: editor, className: "editor ".concat(readonly.current == true ? "readonly-true" : "readonly-false", " ").concat(inputClassName), style: inputStyle }),
            react_1.default.createElement("div", { id: "html-for-init-".concat(id), onClick: onInitContent }),
            react_1.default.createElement("div", { id: "html-for-prev-".concat(id), className: "hidden" }),
            react_1.default.createElement("div", { id: "html-for-sync-".concat(id), onClick: onSyncContent }))));
};
exports.HtmlEditor = HtmlEditor;
exports.default = exports.HtmlEditor;
