"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HtmlEditorFloatInsertToolbar = void 0;
var react_1 = __importDefault(require("react"));
var primeobjects_ui_web_basic_1 = require("primeobjects-ui-web-basic");
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var react_2 = require("@tiptap/react");
var lodash_1 = require("lodash");
var uploader_1 = __importDefault(require("primeobjects-ui-web-application/build/cjs/controls/uploader"));
var FLOAT_MENU_STYLE = {
    border: 'solid 1px #333333',
    backgroundColor: '#ffffff',
    padding: 2,
    marginLeft: 10,
    fontSize: 14,
    display: 'flex'
};
var HtmlEditorFloatInsertToolbar = function (props) {
    var editor = props.editor, attributeName = props.attributeName, recordId = props.recordId, entityName = props.entityName;
    var onUploadPhoto = function (photoInfo) {
        var src = photoInfo.cfSignedResult.signedUrl;
        var rawSrc = photoInfo.cfSignedRawResult.signedUrl;
        editor.commands.setImage({ src: src });
        (0, lodash_1.each)(document.getElementsByTagName('img'), function (img) {
            if (img.src == src) {
                img.onerror = function () {
                    console.log("USING RAW FILE");
                    this.rawSrc = rawSrc;
                    this.src = rawSrc;
                };
            }
        });
    };
    return react_1.default.createElement(react_2.FloatingMenu, { editor: editor },
        react_1.default.createElement("button", { style: FLOAT_MENU_STYLE, onClick: function () { return editor.chain().focus().toggleHeading({ level: 2 }).run(); } }, "H2"),
        react_1.default.createElement("button", { style: FLOAT_MENU_STYLE, onClick: function () { return editor.chain().focus().toggleHeading({ level: 3 }).run(); } }, "H3"),
        react_1.default.createElement("button", { style: FLOAT_MENU_STYLE, onClick: function () { return editor.chain().focus().toggleBulletList().run(); } },
            react_1.default.createElement(primeobjects_ui_web_basic_1.SVG, { src: "/icons/platform/html-editor/material-bullet-list.svg", size: 20 })),
        react_1.default.createElement("button", { style: FLOAT_MENU_STYLE, onClick: function () { return editor.chain().focus().toggleOrderedList().run(); } },
            react_1.default.createElement(primeobjects_ui_web_basic_1.SVG, { src: "/icons/platform/html-editor/material-numbered-list.svg", size: 20 })),
        react_1.default.createElement("button", { style: FLOAT_MENU_STYLE },
            react_1.default.createElement(uploader_1.default, { iconStyle: { width: 20, height: 20 }, hideLabel: true, entityName: entityName, attributeName: attributeName, fileType: "Photo", signedUrlSize: 960, onSuccess: onUploadPhoto, recordId: recordId, fileNamePrefix: (0, primeobjects_helper_util_1.newGuid)(), uiFormat: "icon", iconUrl: "/icons/platform/image.svg", wrapperStyle: { width: 20, height: 20, border: 'none' } })));
};
exports.HtmlEditorFloatInsertToolbar = HtmlEditorFloatInsertToolbar;
exports.default = exports.HtmlEditorFloatInsertToolbar;
