import React from 'react';
import { SVG } from 'primeobjects-ui-web-basic';
import { newGuid } from 'primeobjects-helper-util';
import { FloatingMenu } from '@tiptap/react';
import { each } from 'lodash';
import Uploader from 'primeobjects-ui-web-application/build/cjs/controls/uploader';
var FLOAT_MENU_STYLE = {
    border: 'solid 1px #333333',
    backgroundColor: '#ffffff',
    padding: 2,
    marginLeft: 10,
    fontSize: 14,
    display: 'flex'
};
export var HtmlEditorFloatInsertToolbar = function (props) {
    var editor = props.editor, attributeName = props.attributeName, recordId = props.recordId, entityName = props.entityName;
    var onUploadPhoto = function (photoInfo) {
        var src = photoInfo.cfSignedResult.signedUrl;
        var rawSrc = photoInfo.cfSignedRawResult.signedUrl;
        editor.commands.setImage({ src: src });
        each(document.getElementsByTagName('img'), function (img) {
            if (img.src == src) {
                img.onerror = function () {
                    console.log("USING RAW FILE");
                    this.rawSrc = rawSrc;
                    this.src = rawSrc;
                };
            }
        });
    };
    return React.createElement(FloatingMenu, { editor: editor },
        React.createElement("button", { style: FLOAT_MENU_STYLE, onClick: function () { return editor.chain().focus().toggleHeading({ level: 2 }).run(); } }, "H2"),
        React.createElement("button", { style: FLOAT_MENU_STYLE, onClick: function () { return editor.chain().focus().toggleHeading({ level: 3 }).run(); } }, "H3"),
        React.createElement("button", { style: FLOAT_MENU_STYLE, onClick: function () { return editor.chain().focus().toggleBulletList().run(); } },
            React.createElement(SVG, { src: "/icons/platform/html-editor/material-bullet-list.svg", size: 20 })),
        React.createElement("button", { style: FLOAT_MENU_STYLE, onClick: function () { return editor.chain().focus().toggleOrderedList().run(); } },
            React.createElement(SVG, { src: "/icons/platform/html-editor/material-numbered-list.svg", size: 20 })),
        React.createElement("button", { style: FLOAT_MENU_STYLE },
            React.createElement(Uploader, { iconStyle: { width: 20, height: 20 }, hideLabel: true, entityName: entityName, attributeName: attributeName, fileType: "Photo", signedUrlSize: 960, onSuccess: onUploadPhoto, recordId: recordId, fileNamePrefix: newGuid(), uiFormat: "icon", iconUrl: "/icons/platform/image.svg", wrapperStyle: { width: 20, height: 20, border: 'none' } })));
};
export default HtmlEditorFloatInsertToolbar;
